    @echo off
    if not exist %0 echo YOU MUST DOUBLE_CLICK THIS FILE FROM WINDOWS
    if not exist %0 pause
    if not exist %0 goto :EOF
    type %0 | find /v "    " > %temp%\temp.vbs
    cscript.exe //nologo %temp%\temp.vbs
    del %temp%\temp.vbs
    goto :EOF

'Installation script for HOSTS and PROXY file
'http://ericphelps.com/security/
'Released to Public Domain

Option Explicit
Const HOSTS_URL = "http://www.mvps.org/winhelp2002/hosts.txt"
Const PROXY_URL = "http://www.hostsfile.org/proxy.txt"

Main

Sub Main
	'Declare variables
	Const WINDOWS_FOLDER = 0
	Const SYSTEM_FOLDER = 1
	Dim fs, ws, sc, oTest
	Dim strHostsFolder, strShortcutFolder, strNotepad
	Dim strData, blnDNS, blnSuccess, strMessage, strUser
	
	On Error Resume Next
	
	If MsgBox("In order to update your HOSTS and PROXY settings, this script may need to access the Internet, change registry settings, and modify files. If your PC security warns you about these actions, you should allow them.", vbOkCancel, "Permissions Needed") = vbCancel Then
		Exit Sub
	End If

	'Create objects
	Err.Clear
	Set ws = CreateObject("WScript.Shell")
	Set fs = CreateObject("Scripting.FileSystemObject")
	If Err.Number <> 0 Then
		If MsgBox ("You seem to have a bad or old installation of Microsoft Windows Scripting. I'd like to take you to a Microsoft web page where you can download Scripting Version 5.6. May I launch your default browser to show you the download page?", vbYesNo, "Update Needed") = vbYes Then
			Select Case OsVersion()
				Case 0
					ws.Run "http://msdn.microsoft.com/downloads/list/webdev.asp?frame=true", 1, False
				Case 5
					ws.Run "http://www.microsoft.com/downloads/details.aspx?FamilyId=C717D943-7E4B-4622-86EB-95A22B832CAA&displaylang=en", 1, False
				Case Else
					ws.Run "http://www.microsoft.com/downloads/details.aspx?FamilyId=0A8A18F6-249C-4A72-BFCF-FC6AF26DC390&displaylang=en", 1, False
			End Select
		End If
		MsgBox "After you finish updating Scripting, you can re-run this installation script."
		Exit Sub
	Else
		Status "Windows Scripting seems functional"
	End If
	
	'Test for optional WMI
	Set oTest = Nothing
	On Error Resume Next
	Err.Clear
	Set oTest = GetObject("winmgmts:\\.\root\CIMV2")
	If oTest Is Nothing Then
		Status "WMI is not functioning"
		If OsVersion() = 4 Then
			If MsgBox ("Although it is NOT actually required, having WMI installed on on this PC would allow finer control over this installation. May I take you to a Microsoft web page where you can download WMI?", vbYesNo, "Optional Update") = vbYes Then
				ws.Run "http://www.microsoft.com/downloads/details.aspx?FamilyID=afe41f46-e213-4cbf-9c5b-fbf236e0e875&DisplayLang=en", 1, False
				MsgBox "After you complete the installation of WMI, you can re-run this script."
				Exit Sub
			End If
		End If
	Else
		Status "WMI seems functional"
		Set oTest = Nothing
	End If
	
	'Verify user is an Admin
	strUser = UserName()
	If strUser <> "" Then
		If Not IsAdmin(strUser) Then
			Status "User is NOT a member of Administrators group"
			If MsgBox("You'll have a better chance of succeeding at this if you log in as an ""Administrator"" (one of the following user names):" & vbCrLf & EnumerateAdmins & vbCrLf & "Would you like to TRY to continue logged in as """ & strUser & """?", vbYesNo, "Administrator Login") <> vbYes Then
				Exit Sub
			End If
		Else
			Status "User is a member of Administrators group"
		End If
	Else
		Status "Unable to verfify Admin membership. Will assume it's okay."
	End If

	'Find the Hosts folder
	strHostsFolder = fs.BuildPath(fs.GetSpecialFolder(SYSTEM_FOLDER).Path, "drivers\etc")
	If Not fs.FolderExists(strHostsFolder) Then
		strHostsFolder = fs.GetSpecialFolder(WINDOWS_FOLDER).Path
	End If
	Status "Presuming HOSTS at " & strHostsFolder

	'Find Notepad
	strNotepad = fs.BuildPath(fs.GetSpecialFolder(SYSTEM_FOLDER).Path, "Notepad.exe")
	If Not fs.FileExists(strNotepad) Then
		strNotepad = fs.BuildPath(fs.GetSpecialFolder(WINDOWS_FOLDER).Path, "Notepad.exe")
	End If
	Status "Presuming NOTEPAD at " & strNotepad
	
	'Verify the DNS Cache service is stopped
	blnDNS = False 
	If ServiceState("DNSCache") <> "Stopped" Then blnDNS = True
	If ServiceStartMode("DNSCache") = "Auto" Then blnDNS = True
	If ServiceStartMode("DNSCache") = "" Then blnDNS = True
	If OsVersion() < 5 Then blnDNS = False 'Win9X has no DNSCache service
	If blnDNS Then 
		If MsgBox("NOTE: In order for you to use a large HOSTS file, I'll need to disable the ""DNS Client"" service. If this computer is part of a domain (if you use this PC to log in at work), you should check with your IT department first. Proceed?", vbYesNo, "Disable DNS Client Service") = vbYes Then
			'Stop the DNS Client service
			Status "Stopping DNSCache service"
			StopService "DNSCache"
			WScript.Sleep 2000
			If ServiceState("DNSCache") = "Running" Then 'Assume no news is good news
				MsgBox "I was unable to stop the ""DNS Client"" service. You (and by extension, I) may not have permission to muck about with the things we are currently mucking about with. Perhaps you should try again later." 
				Exit Sub
			End If
			'Disable the DNS Client service so it won't start automatically next time
			If ServiceStartMode("DNSCache") = "Auto" Then
				Status "Setting DNSCache service to ""disabled"""
				ws.RegWrite "HKLM\SYSTEM\CurrentControlSet\Services\Dnscache\Start", 4, "REG_DWORD"
				If ws.RegRead("HKLM\SYSTEM\CurrentControlSet\Services\Dnscache\Start") <> 4 Then
					'If we can't disable the DNS Client via the registry, try using the NET command...
					ws.Run "net.exe config DNSCache start=disabled", 0, False
					'...and cry about the problem regardless of whether NET worked or not
					If MsgBox("I was unable to reliably disable the ""DNS Client"" service. It really should be disabled or set to manual. Do you want to ignore this error and continue?", vbYesNo, "Service Error") <> vbYes Then
						Exit Sub
					End If
				End If
			End If
		Else
			MsgBox "No changes were made. You may re-run this script again later."
			Exit Sub
		End If
	End If
	
	'Talk the user into disabling "Search from the Address bar"
	If ws.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main\AutoSearch") <> 0 Then
		If MsgBox("The ""Search from the Address bar"" feature in Internet Explorer can sometimes misbehave when used with a restrictive hosts file. This can cause a web page to be replaced by a search error page. May I disable address bar searching?", vbYesNo, "IE Settings Change") = vbYes Then
			ws.RegWrite "HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main\AutoSearch", 0, "REG_DWORD"
			If ws.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main\AutoSearch") <> 0 Then
				Status "Unable to disable the ""Search from the Address bar"" feature in IE"
				MsgBox "I was unable to turn off address bar searching. If it ends up causing problems in the future, you can turn the address bar search feature on and off yourself from the ""Advanced"" tab of the ""Internet Properties"" control."
			Else
				Status "Disabled the ""Search from the Address bar"" feature in IE"
				If MsgBox("Okay. I did that for you (" & UserName() & "). Assuming there are other users, should I put a script in the ""Startup"" folder that will turn off address bar searching for all the other users?", vbYesNo, "Other Users") = vbYes Then
					AddressBarSearchScript ws.SpecialFolders("AllUsersStartup")
				End If
			End If
		Else
			MsgBox "No problem. You can turn the address bar search feature on and off yourself from the ""Advanced"" tab of the ""Internet Properties"" control."
		End If
	Else
		Status """Search from the Address bar"" is already disabled."
	End If

	'Get the most recent HOSTS file
	If MsgBox("Should I download and install the latest HOSTS file (and rename any existing file as ""hosts.bak"")?", vbYesNo, "Download HOSTS") = vbYes Then
		'Download the HOSTS file
		strData = ""
		Status "Downloading HOSTS file..."
		strData = GetData(HOSTS_URL)
		If Len(strData) < 100000 Then
			Status "Length of downloaded HOSTS file was " & Len(strData) & " bytes."
			MsgBox "Sorry, I couldn't download the HOSTS file. Maybe the Internet was vaporized?", ,"Error"
		Else
			'Verify permissions on the hosts file (if it exists)
			If fs.FileExists(fs.BuildPath(strHostsFolder, "hosts")) Then
				Err.Clear
				fs.GetFile(fs.BuildPath(strHostsFolder, "hosts")).Attributes = 32 'Clear everything except archive
				If fs.GetFile(fs.BuildPath(strHostsFolder, "hosts")).Attributes <> 32 Then
					Status "WARNING - Permission on hosts can't be reset"
					If MsgBox("I don't seem to be able to set permissions on the ""hosts"" file. You may not have permission to modify the ""hosts"" file. Should I ignore this problem and continue?", vbYesNo, "Error") = vbNo Then
						Exit Sub
					End If
				Else
					Status "Attributes OK on existing hosts file"
				End If
			End If
			'Verify permissions on hosts.bak backup file (if it exists)
			If fs.FileExists(fs.BuildPath(strHostsFolder, "hosts.bak")) Then
				Err.Clear
				fs.GetFile(fs.BuildPath(strHostsFolder, "hosts.bak")).Attributes = 32 'Clear everything except archive
				If fs.GetFile(fs.BuildPath(strHostsFolder, "hosts.bak")).Attributes <> 32 Then
					Status "WARNING - Permission on hosts.bak can't be reset"
					If MsgBox("I don't seem to be able to set permissions on the ""hosts.bak"" file (the existing backup file). This means I may not be able to back things up before I make changes. Should I ignore this problem and continue?", vbYesNo, "Error") = vbNo Then
						Exit Sub
					End If
				Else
					Status "Attributes OK on existing hosts.bak file"
				End If
			End If
			'Back up the old hosts file
			If fs.FileExists(fs.BuildPath(strHostsFolder, "hosts.bak")) Then
				Status "Deleting old ""hosts.bak"" file"
				Err.Clear
				fs.DeleteFile fs.BuildPath(strHostsFolder, "hosts.bak"), True
				If Err.Number <> 0 Then
					Status "WARNING - Can't delete old hosts.bak file"
					If MsgBox("This is getting pretty scary! I couldn't delete your existing backup file. This means I will *NOT* be able to back things up for you. Should I ignore this error and continue?", vbYesNo, "Error") = vbNo Then
						Exit Sub
					End If
				End If
			End If
			If fs.FileExists(fs.BuildPath(strHostsFolder, "hosts")) Then
				Status "Renaming existing ""hosts"" file to ""hosts.bak"""
				Err.Clear
				fs.GetFile(fs.BuildPath(strHostsFolder, "hosts")).Name = "hosts.bak"
				If Err.Number <> 0 Then
					Status "WARNING - Can't rename existing hosts file"
					If MsgBox("I couldn't backup your existing hosts file. If things continue to go wrong (which is how the universe works), you could wipe out your hosts file, have no backup, and tear a hole in space-time. Should I continue down the path of almost certain doom?", vbYesNo, "Error") = vbNo Then
						Exit Sub
					End If
				End If
			End If
			'Write the downloaded hosts data to the file
			Status "Saving new ""hosts"" file"
			If Not String2File(strData, fs.BuildPath(strHostsFolder, "hosts")) Then
				MsgBox "Sorry, I couldn't save the new ""hosts"" file. You may not have permission to modify the file.",,"Error"
				Exit Sub
			End If
		End If
	End If

	'Create HOST editor shortcut
	If MsgBox("Should I create a desktop shortcut to allow you to easily edit your HOSTS file?", vbYesNo, "HOST Editing Shortcut") = vbYes Then
		strShortcutFolder = ChooseOne("Install DESKTOP editing shortcut for:", "HOST Editing Shortcut", "Only Me" & vbTab & "All Users")
		'If a popup killer stops the "ChooseOne" dialog, fail gracefully to a shortcut for the current user
		If strShortcutFolder = "All Users" Then
			Status "Creating HOSTS editing shortcut for all users"
			strShortcutFolder = ws.SpecialFolders("AllUsersDesktop")
		Else
			Status "Creating HOSTS editing shortcut for current user only"
			strShortcutFolder = ws.SpecialFolders("Desktop")
		End If
		Set sc = ws.CreateShortcut(fs.BuildPath(strShortcutFolder , "Hosts File.lnk"))
		sc.TargetPath = """" & strNotepad & """"
		sc.Arguments = """" & fs.BuildPath(strHostsFolder, "hosts") & """"
		sc.WorkingDirectory = """" & strHostsFolder & """"
		sc.WindowStyle = 2
		sc.Description = "Allows editing of the HOSTS file used to block certain Internet web sites."
		sc.IconLocation = strNotepad
		sc.Save
	End If
	
	'Get the most recent PROXY file
	If MsgBox("Should I download and install the latest PROXY file (and rename any existing file as ""proxy.bak"")?", vbYesNo, "Download PROXY") = vbYes Then
		'Download the PROXY file
		strData = ""
		Status "Downloading PROXY file..."
		strData = GetData(PROXY_URL)
		If Len(strData) < 10000 Then
			Status "Length of downloaded PROXY file was " & Len(strData) & " bytes."
			MsgBox "Sorry, I couldn't download the PROXY file. Maybe the Internet was vaporized?", ,"Error"
		Else
			'Verify permissions on the proxy file (if it exists)
			If fs.FileExists(fs.BuildPath(strHostsFolder, "proxy")) Then
				Err.Clear
				fs.GetFile(fs.BuildPath(strHostsFolder, "proxy")).Attributes = 32 'Clear everything except archive
				If fs.GetFile(fs.BuildPath(strHostsFolder, "proxy")).Attributes <> 32 Then
					Status "WARNING - Permission on proxy can't be reset"
					If MsgBox("I don't seem to be able to set permissions on the ""proxy"" file. You may not have permission to modify the ""proxy"" file. Should I ignore this problem and continue?", vbYesNo, "Error") = vbNo Then
						Exit Sub
					End If
				Else
					Status "Attributes OK on existing proxy file"
				End If
			End If
			'Verify permissions on proxy.bak backup file (if it exists)
			If fs.FileExists(fs.BuildPath(strHostsFolder, "proxy.bak")) Then
				Err.Clear
				fs.GetFile(fs.BuildPath(strHostsFolder, "proxy.bak")).Attributes = 32 'Clear everything except archive
				If fs.GetFile(fs.BuildPath(strHostsFolder, "proxy.bak")).Attributes <> 32 Then
					Status "WARNING - Permission on proxy.bak can't be reset"
					If MsgBox("I don't seem to be able to set permissions on the ""proxy.bak"" file (the existing backup file). This means I may not be able to back things up before I make changes. Should I ignore this problem and continue?", vbYesNo, "Error") = vbNo Then
						Exit Sub
					End If
				Else
					Status "Attributes OK on existing proxy.bak file"
				End If
			End If
			'Back up the old proxy file
			If fs.FileExists(fs.BuildPath(strHostsFolder, "proxy.bak")) Then
				Status "Deleting old ""proxy.bak"" file"
				Err.Clear
				fs.DeleteFile fs.BuildPath(strHostsFolder, "proxy.bak"), True
				If fs.FileExists(fs.BuildPath(strHostsFolder, "proxy.bak")) Then
					Status "WARNING - Can't delete old proxy.bak file"
					If MsgBox("I couldn't delete your existing backup file. This means I will NOT be able to back things up for you. Should I ignore this error and continue?", vbYesNo, "Error") = vbNo Then
						Exit Sub
					End If
				End If
			End If
			If fs.FileExists(fs.BuildPath(strHostsFolder, "proxy")) Then
				Status "Renaming existing ""proxy"" file to ""proxy.bak"""
				Err.Clear
				fs.GetFile(fs.BuildPath(strHostsFolder, "proxy")).Name = "proxy.bak"
				If Err.Number <> 0 Then
					Status "WARNING - Can't rename existing proxy file"
					If MsgBox("I couldn't backup your existing proxy file. If things continue to go wrong (which is how the universe works), you could wipe out your proxy file, have no backup, and tear a hole in space-time. Should I continue down the path of almost certain doom?", vbYesNo, "Error") = vbNo Then
						Exit Sub
					End If
				End If
			End If
			'Write the downloaded proxy data to the file
			Status "Saving new ""proxy"" file"
			If Not String2File(strData, fs.BuildPath(strHostsFolder, "proxy")) Then
				MsgBox "Sorry, I couldn't save the new ""proxy"" file. You may not have permission to modify the file.",,"Error"
				Exit Sub
			End If
		End If
	End If

	'Create PROXY editor shortcut
	If MsgBox("Should I create desktop shortcut to allow you to easily edit your PROXY file?", vbYesNo, "PROXY Editing Shortcut") = vbYes Then
		strShortcutFolder = ChooseOne("Install DESKTOP editing shortcuts for:", "PROXY Editing Shortcut", "Only Me" & vbTab & "All Users")
		If strShortcutFolder = "All Users" Then
			Status "Creating PROXY editing shortcut for all users"
			strShortcutFolder = ws.SpecialFolders("AllUsersDesktop")
		Else
			Status "Creating PROXY editing shortcut for current user only"
			strShortcutFolder = ws.SpecialFolders("Desktop")
		End If
		Set sc = ws.CreateShortcut(fs.BuildPath(strShortcutFolder, "Proxy File.lnk"))
		sc.TargetPath = """" & strNotepad & """"
		sc.Arguments = """" & fs.BuildPath(strHostsFolder, "proxy") & """"
		sc.WorkingDirectory = """" & strHostsFolder & """"
		sc.WindowStyle = 2
		sc.Description = "Allows editing of the PROXY file used to block certain Internet web pages."
		sc.IconLocation = strNotepad
		sc.Save
	End If
	
	'Activate the PROXY file as a PAC
	If fs.FileExists(fs.BuildPath(strHostsFolder, "proxy")) Then
		If MsgBox("NOTE: Activating a PROXY / PAC file may override any existing proxy settings. Home users usually don't use a proxy, but if this computer is a work PC, you should check with your IT department first. Proceed?", vbYesNo, "Override Proxy Settings") = vbYes Then
			If MsgBox("Should I enable the PROXY file to be used as a PAC for Internet Explorer for you (" & UserName() & ")?", vbYesNo, "Enable PROXY / PAC") = vbYes Then
				ws.RegWrite "HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings\AutoConfigURL", "file://" & Replace(fs.BuildPath(strHostsFolder, "proxy"), "\", "/"), "REG_SZ"
				ws.RegWrite "HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings\ProxyBypass", 0, "REG_DWORD"
				ws.RegWrite "HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings\ProxyEnable", 0, "REG_DWORD"
				ws.RegWrite "HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings\Zones\1\Flags", 211, "REG_DWORD"
				ws.RegWrite "HKCU\Software\Policies\Microsoft\Windows\CurrentVersion\Internet Settings\EnableAutoProxyResultCache", 0, "REG_DWORD"
				blnSuccess = True
				If ws.RegRead("HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings\AutoConfigURL") <> "file://" & Replace(fs.BuildPath(strHostsFolder, "proxy"), "\", "/") Then blnSuccess = False
				If ws.RegRead("HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings\ProxyBypass") <> 0 Then blnSuccess = False
				If ws.RegRead("HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings\ProxyEnable") <> 0 Then blnSuccess = False
				If ws.RegRead("HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings\Zones\1\Flags") <> 211 Then blnSuccess = False
				If ws.RegRead("HKCU\Software\Policies\Microsoft\Windows\CurrentVersion\Internet Settings\EnableAutoProxyResultCache") <> 0 Then  blnSuccess = False
				If Not blnSuccess Then
					MsgBox "I was unable to make the changes necessary to use your proxy file as a PAC for Internet Explorer."
				End If
			End If
			If MsgBox("Should I put a script in the ""Startup"" folder that will set up the PROXY file as a PAC for IE for all other users?", vbYesNo, "Enable PROXY / PAC for All Users") = vbYes Then
				PacEnableScript ws.SpecialFolders("AllUsersStartup"), strHostsFolder
			End If
		End If
	End If	

	MsgBox "Finished",,"Finished"
End Sub

Function GetData(strUrl)
Dim web
Const WinHttpRequestOption_EnableRedirects = 6
	Set web = Nothing
	On Error Resume Next
	Set web = CreateObject("WinHttp.WinHttpRequest.5.1")
	If web Is Nothing Then Set web = CreateObject("WinHttp.WinHttpRequest")
	If web Is Nothing Then Set web = CreateObject("MSXML2.ServerXMLHTTP")
	If web Is Nothing Then Set web = CreateObject("Microsoft.XMLHTTP")
	If web Is Nothing Then
		GetData = ""
		Exit Function
	End If
	web.Option(WinHttpRequestOption_EnableRedirects) = True
	web.Open "GET", strURL, False
	web.SetRequestHeader "REFERER", strUrl
 	web.SetRequestHeader "User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)"
 	web.SetRequestHeader "Accept", "text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5"
 	web.SetRequestHeader "Accept-Language", "en-us,en;q=0.5"
 	web.SetRequestHeader "Accept-Charset", "ISO-8859-1,utf-8;q=0.7,*;q=0.7"
	web.Send
	If web.Status = "200" Then
		GetData = web.ResponseText
	Else
		GetData = ""
	End If
End Function

Sub StopService(strServiceName)
	Dim blnDependencies, objWMI, objService, colServices
	On Error Resume Next
	Err.Clear
	Set objWMI = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
	Set colServices = objWMI.ExecQuery("Associators of {Win32_Service.Name='" & strServiceName & "'} Where AssocClass=Win32_DependentService " & "Role=Antecedent" )
	blnDependencies = False 
	For Each objService in colServices
		blnDependencies = True 
		objService.StopService
	Next
	If blnDependencies = True Then 
		Wscript.Sleep 20000
	End If
	Set colServices = objWMI.ExecQuery("Select * from Win32_Service where Name='" & strServiceName & "'")
	For Each objService in colServices
		objService.StopService()
	Next
	Set objWMI = Nothing
	'If WMI fails, try running NET.EXE to stop service
	If Err.Number <> 0 Then
		CreateObject("WScript.Shell").Run "net.exe stop " & strServiceName, 0, False
	End If
End Sub

Function ServiceState(strServiceName)
	'Returns "Running", "Stopped", "Starting", "Stopping", or ""
	Dim objWMI, colServices, objService, strState, strStartMode
	On Error Resume Next
	Err.Clear
	Set objWMI = GetObject("winmgmts:\\.\root\CIMV2")
	Set colServices = objWMI.ExecQuery("SELECT * FROM Win32_Service WHERE NAME='" & strServiceName & "'", "WQL", 48)
	For Each objService In colServices
		strState = objService.State
	Next
	If Err.Number <> 0 Then
		ServiceState = "" 'Return empty string on WMI failure
	Else
		ServiceState = strState
	End If
	Set objWMI = Nothing
End Function

Function ServiceStartMode(strServiceName)
	'Returns "Auto", "Disabled", "Manual", or ""
	Dim objWMI, colServices, objService, strState, strStartMode
	On Error Resume Next
	Err.Clear
	Set objWMI = GetObject("winmgmts:\\.\root\CIMV2")
	Set colServices = objWMI.ExecQuery("SELECT * FROM Win32_Service WHERE NAME='" & strServiceName & "'", "WQL", 48)
	For Each objService In colServices
		strStartMode = objService.StartMode
	Next
	If Err.Number <> 0 Then
		ServiceStartMode = "" 'Return empty string on WMI failure
	Else
		ServiceStartMode = strStartMode
	End If
	Set objWMI = Nothing
End Function

Function OsVersion()
	'Returns the base number for the OS (4 = Win9x, 5 = 2K/XP, 0 = unknown)
	Dim lngVersion, strVersion, objWMI, colSystems, objOS
	On Error Resume Next
	Err.Clear
	Set objWMI = GetObject("winmgmts:\\.\root\CIMV2")
	Set colSystems = objWMI.ExecQuery("SELECT * FROM Win32_OperatingSystem", "WQL", 48)
	For Each objOS In colSystems
		strVersion = objOS.Version
	Next
	If Err.Number <> 0 Then
		strVersion = "4" 'Assume lack of WMI means Windows 9X
	End If
	If InStr(strVersion, ".") > 1 Then
		strVersion = Left(strVersion, InStr(strVersion, ".") - 1)
	End If
	If IsNumeric(strVersion) Then
		lngVersion = Clng(strVersion)
	Else
		lngVersion = 0
	End If
	OsVersion = lngVersion
	Set objWMI = Nothing
End Function

Function IsAdmin(strUserName)
	Dim objWMI, colUsers, objUser, strGroup, blnIsAdmin, blnHasAdmins
	On Error Resume Next
	Err.Clear
	Set objWMI = GetObject("winmgmts:\\.\root\CIMV2")
	Set colUsers = objWMI.ExecQuery("SELECT * FROM Win32_GroupUser", "WQL", 48)
	If Err.Number <> 0 Then
		'Assume WMI failure means Win9X, implying user is an Administrator
		IsAdmin = True
	Else
		blnIsAdmin = False
		blnHasAdmins = False
		For Each objUser In colUsers
			strGroup = objUser.GroupComponent
			strGroup = Split(strGroup, "=")
			If strGroup(UBound(strGroup)) = """Administrators""" Then
				blnHasAdmins = True
				strUser = objUser.PartComponent
				strUser = Split(strUser, "=")
				If strUser(UBound(strUser)) = """" & strUserName & """" Then
					blnIsAdmin = True
				End If
			End If
		Next
	End If
	If blnHasAdmins = False Then
		'If there are no members of the Administrators group, assume everybody is an admin
		IsAdmin = True
	Else
		IsAdmin = blnIsAdmin 
	End If
End Function

Function EnumerateAdmins()
	'Returns space-delimited quoted user names
	Dim objWMI, colUsers, objUser, strGroup, strUser, strUsers, blnIsAdmin
	On Error Resume Next
	Err.Clear
	strUsers = ""
	Set objWMI = GetObject("winmgmts:\\.\root\CIMV2")
	Set colUsers = objWMI.ExecQuery("SELECT * FROM Win32_GroupUser", "WQL", 48)
	If Err.Number = 0 Then
		For Each objUser In colUsers
			strGroup = objUser.GroupComponent
			strGroup = Split(strGroup, "=")
			If strGroup(UBound(strGroup)) = """Administrators""" Then
				strUser = objUser.PartComponent
				strUser = Split(strUser, "=")
				If strUsers <> "" Then strUsers = strUsers & " "
				strUsers = strUsers & strUser(UBound(strUser))
			End If
		Next
	End If
	EnumerateAdmins = strUsers
End Function

Function UserName()
	Dim objWMI, colComputers, objComputer, strUser, ws, env
	On Error Resume Next
	strUser = ""
	Err.Clear
	Set objWMI = GetObject("winmgmts:\\.\root\CIMV2")
	Set colComputers = objWMI.ExecQuery("SELECT * FROM Win32_ComputerSystem", "WQL", 48)
	If Err.Number <> 0 Then
		'WMI Failure. Try environment
		Set ws = CreateObject("Wscript.Shell")
		Set env = ws.Environment("Process")
		strUser = env.Item("USERNAME")
	Else
		For Each objComputer In colComputers
			strUser = objComputer.UserName
		Next
		If Instr(strUser, "\") Then
			strUser = Mid(strUser, Instr(strUser, "\") + 1)
		End If
	End If
	Set objWMI = Nothing
	UserName = strUser
End Function


Function String2File(strData, strFileName)
'Writes a string to a file. Returns True if success.
Dim fs 'As Scripting.FileSystemObject
Dim ts 'As Scripting.TextStream
Dim lngChar, strBlock, intChar, dtTimeStamp
Const ForWriting = 2
	Set fs = CreateObject("Scripting.FileSystemObject")
	On Error Resume Next
	If fs.FileExists(strFileName) Then
		dtTimeStamp = fs.GetFile(strFileName).DateLastModified
	Else
		dtTimeStamp = CDate(0)
	End If
	Err.Clear
	Set ts = fs.OpenTextFile(strFileName, ForWriting, True)
	ts.Write strData
	If Err.Number <> 0 Then
		'Must have hit one of the "problem characters" between 128 and 159
		For lngChar = 1 To Len(strData) Step 100
			Err.Clear
			ts.Write Mid(strData, lngChar, 100)
			If Err.Number <> 0 Then
				'This block of 100 must have the problem. Write them one-at-a-time
				strBlock = Mid(strData, lngChar, 100)
				For intChar = 1 To Len(strBlock)
					ts.Write Chr(255 And AscW(Mid(strBlock, intChar)))
				Next
			End If
		Next
	End If
	ts.Close
	If fs.FileExists(strFileName) Then
		If dtTimeStamp = fs.GetFile(strFileName).DateLastModified Then
			String2File = False
		Else
			String2File = True
		End If
	Else
		String2File = False
	End If
End Function

Sub Status(strMessage)
	'Writes a message to the UI only if the script is running under CSCRIPT
	If Lcase(Right(Wscript.FullName, 12)) = "\cscript.exe" Then
		Wscript.Echo strMessage
	End If
End Sub

Function AddressBarSearchScript(strFolder)
	Dim strData
	strData = ""
	strData = strData & "::  This file disables the ""Search from the Address bar"" feature " & vbCrLf
	strData = strData & "::  in Internet Explorer. This feature can cause problems when " & vbCrLf
	strData = strData & "::  used with restrictive hosts files. This computer uses such a " & vbCrLf
	strData = strData & "::  hosts file. The person who installed the hosts file elected to " & vbCrLf
	strData = strData & "::  install this file to make sure other users did not experience " & vbCrLf
	strData = strData & "::  problems with Internet Explorer replacing a good web page with " & vbCrLf
	strData = strData & "::  a search web page." & vbCrLf & vbCrLf
	'For some wacky reason, batch files can do anything.
	'Like create a Win98 Registry file (works on 2K/XP) and merge it.
	'If I'd done this with a script, it would fire security alerts.
	strData = strData & "@echo off" & vbCrLf
	strData = strData & " >""%temp%\DisableAddressBarSearch.reg"" echo REGEDIT4" & vbCrLf
	strData = strData & ">>""%temp%\DisableAddressBarSearch.reg"" echo." & vbCrLf
	strData = strData & ">>""%temp%\DisableAddressBarSearch.reg"" echo [HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main\]" & vbCrLf
	strData = strData & ">>""%temp%\DisableAddressBarSearch.reg"" echo ""AutoSearch""=dword:00000000" & vbCrLf
	strData = strData & ">>""%temp%\DisableAddressBarSearch.reg"" echo." & vbCrLf
	strData = strData & "start /w regedit.exe /s ""%temp%\DisableAddressBarSearch.reg""" & vbCrLf
	strData = strData & "del ""%temp%\DisableAddressBarSearch.reg"" > nul" & vbCrLf
	strData = strData & "cls" & vbCrLf
	strData = strData & "exit"
	AddressBarSearchScript = String2File(strData, CreateObject("Scripting.FileSystemObject").BuildPath(strFolder, "Disable Address Bar Searching.bat")) 
End Function

Function PacEnableScript(strFolder, strHostsFolder)
	Dim strData
	strData = ""
	strData = strData & "::  This file enables a ""Proxy Access Control"" (PAC) script " & vbCrLf
	strData = strData & "::  in Internet Explorer (IE). A PAC is used to block access to " & vbCrLf
	strData = strData & "::  certain Internet resources (web pages, pictures, etc.). " & vbCrLf
	strData = strData & "::  The person who installed the proxy file elected to install " & vbCrLf
	strData = strData & "::  this file to make sure other users of this computer would " & vbCrLf
	strData = strData & "::  automatically get their IE configured to use the proxy file " & vbCrLf
	strData = strData & "::  as a PAC as soon as they logged in." & vbCrLf & vbCrLf
	'For some wacky reason, batch files can do anything.
	'Like create a Win98 Registry file (works on 2K/XP) and merge it.
	'If I'd done this with a script, it would fire security alerts.
	strData = strData & "@echo off" & vbCrLf
	strData = strData & " >""%temp%\EnablePac.reg"" echo REGEDIT4" & vbCrLf
	strData = strData & ">>""%temp%\EnablePac.reg"" echo." & vbCrLf
	strData = strData & ">>""%temp%\EnablePac.reg"" echo [HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Internet Settings]" & vbCrLf
	strData = strData & ">>""%temp%\EnablePac.reg"" echo ""AutoConfigURL""=""file://" & Replace(CreateObject("Scripting.FileSystemObject").BuildPath(strHostsFolder, "proxy"), "\", "/") & """" & vbCrLf
	strData = strData & ">>""%temp%\EnablePac.reg"" echo ""ProxyEnable""=dword:00000000" & vbCrLf
	strData = strData & ">>""%temp%\EnablePac.reg"" echo ""ProxyBypass""=dword:00000000" & vbCrLf
	'strData = strData & ">>""%temp%\EnablePac.reg"" echo ""ProxyOverride""=-" & vbCrLf
	'strData = strData & ">>""%temp%\EnablePac.reg"" echo "";roxyServer""=-" & vbCrLf
	strData = strData & ">>""%temp%\EnablePac.reg"" echo." & vbCrLf
	strData = strData & ">>""%temp%\EnablePac.reg"" echo [HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Internet Settings\Zones\1]" & vbCrLf
	strData = strData & ">>""%temp%\EnablePac.reg"" echo ""Flags""=dword:000000d3" & vbCrLf
	strData = strData & ">>""%temp%\EnablePac.reg"" echo." & vbCrLf
	strData = strData & ">>""%temp%\EnablePac.reg"" echo [HKEY_CURRENT_USER\Software\Policies\Microsoft\Windows\CurrentVersion\Internet Settings]" & vbCrLf
	strData = strData & ">>""%temp%\EnablePac.reg"" echo ""EnableAutoProxyResultCache""=dword:00000000" & vbCrLf
	strData = strData & ">>""%temp%\EnablePac.reg"" echo." & vbCrLf
	strData = strData & "start /w regedit.exe /s ""%temp%\EnablePac.reg""" & vbCrLf
	strData = strData & "del ""%temp%\EnablePac.reg"" > nul" & vbCrLf
	strData = strData & "cls" & vbCrLf
	strData = strData & "exit"
	PacEnableScript = String2File(strData, CreateObject("Scripting.FileSystemObject").BuildPath(strFolder, "Enable PAC File.bat")) 
End Function

Function ChooseOne(strPrompt, strTitle, strTabDelimitedChoices)
'Returns one of several string choices. 
'Returns empty string if there is a problem.
Dim fs, web, doc
Dim strFile, strChoice
Dim intChars
Dim dtTime
	On Error Resume Next
	Set web = CreateObject("InternetExplorer.Application")
	If web Is Nothing Then
		ChooseOne = ""
		Exit Function
	End If
	'Increase displayed width to accomodate longest string choice
	intChars = 0
	For Each strChoice In Split(strTabDelimitedChoices, vbTab)
		If Len(strChoice) > intChars Then intChars = Len(strChoice)
	Next
	If intChars > 20 Then
		web.Width = 250 + 6 * (intChars - 20)
	Else
		web.Width = 250
	End If
	web.Height = 200
	web.Offline = True
	web.AddressBar = False
	web.MenuBar = False
	web.StatusBar = False
	web.Silent = True
	web.ToolBar = False
	web.Navigate "about:blank"
	'Wait for the browser to navigate to nowhere
	dtTime = Now
	Do While web.Busy
		'Don't wait more than 5 seconds
		Wscript.Sleep 100
		If (dtTime + 5/24/60/60) < Now Then
			ChooseOne = ""
			web.Quit
			Exit Function
		End If
	Loop
	'Wait for a good reference to the browser document
	Set doc = Nothing
	dtTime = Now
	Do Until Not doc Is Nothing
		Wscript.Sleep 100
		Set doc = web.Document
		'Don't wait more than 5 seconds
		If (dtTime + 5/24/60/60) < Now Then
			ChooseOne = ""
			web.Quit
			Exit Function
		End If
	Loop
	'Write the HTML form
	doc.Write "<html><head><title>" & strTitle & "</title></head>"
	doc.Write "<body><b>" & strPrompt & "</b><br><form><select name=""choice"">"
	For Each strChoice In Split(strTabDelimitedChoices, vbTab)
		doc.Write "<option value=""" & strChoice & """>" & strChoice
	Next
	doc.Write "</select>"
	doc.Write "<br><br><input type=button "
	doc.Write "name=submit "
	doc.Write "value=""OK"" onclick='javascript:submit.value=""Done""'>"
	doc.Write "</form></body></html>"
	'Show the form
	web.Visible = True
	'Wait for the user to choose, but fail gracefully if a popup killer.
	Err.Clear
	Do Until doc.Forms(0).elements("submit").Value <> "OK"
		Wscript.Sleep 100
		If doc Is Nothing Then
			ChooseOne = ""
			web.Quit
			Exit Function
		End If
		If Err.Number <> 0 Then
			ChooseOne = ""
			web.Quit
			Exit Function
		End If
	Loop
	'Retrieve the chosen value
	ChooseOne = doc.Forms(0).elements("choice").Value
	web.Quit
End Function